RemoveUselessBuffs_Setup = {
	class = false;
	buffs = {};
	buffsToRemove = {};
	showRemoveMessage = true;
};

RemoveUselessBuffs_BuffFilter = "HELPFUL";

function RemoveUselessBuffs_OnLoad()
	local _, class = UnitClass("player");
	local ok = false;
	local cmd = "REMOVEUSELESSBUFFS";
	for k, v in REMOVEUSELESSBUFFS_SLASHCOMMANDS do
		setglobal("SLASH_"..cmd..k, v);
	end
	SlashCmdList[cmd] = RemoveUselessBuffs_SlashCommand;
	local frame = this;
	local _, class = UnitClass("player");
	RemoveUselessBuffs_Setup.class = class;
	-- save memory
	for k, v in REMOVEUSELESSBUFFS_BUFF_DATABASE do
		if ( k ~= class ) then
			REMOVEUSELESSBUFFS_BUFF_DATABASE[k] = nil;
		end
	end
	frame:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS");
end

function RemoveUselessBuffs_GetNumberOfBuffs()
	for i = 1, REMOVEUSELESSBUFFS_MAX_BUFFS do
		index = GetPlayerBuff(i, RemoveUselessBuffs_BuffFilter);
		if ( index < 0 ) then
			return i-1;
		end
	end
	return REMOVEUSELESSBUFFS_MAX_BUFFS;
end

function RemoveUselessBuffs_OnEvent()
	if ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS" ) then
		local numBuffs = RemoveUselessBuffs_GetNumberOfBuffs();
		if ( numBuffs > REMOVEUSELESSBUFFS_THRESHOLD_BUFFS ) then
			RemoveUselessBuffs_ScanAndRemoveBuffs(numBuffs - REMOVEUSELESSBUFFS_THRESHOLD_BUFFS);
		end
		return;
	end
end

function RemoveUselessBuffs_Print(msg, r, g, b)
	if ( not r ) then r = 1; end
	if ( not g ) then r = 1; end
	if ( not b ) then r = 0.1; end
	ChatFrame1:AddMessage(msg, r, g, b, 1);
end

function RemoveUselessBuffs_GetHighestRemoveIndex()
	local highest = -1;
	local highestIndex = -1;
	for k, v in RemoveUselessBuffs_Setup.buffsToRemove do
		if v > highest then 
			highest = v;
			highestIndex = k;
		end
	end
	return highestIndex, highest;
end

function RemoveUselessBuffs_ScanAndRemoveBuffs(numBuffs)
	local removed = 0;
	local index,i,t,n;
	local buffName;
	for i = REMOVEUSELESSBUFFS_MAX_BUFFS, 1, -1 do
		index = GetPlayerBuff(i, RemoveUselessBuffs_BuffFilter);
		if ( index >= 0 ) then
			t = GetPlayerBuffTexture(index);
			if ( t ) then
				RemoveUselessBuffsTooltip:SetPlayerBuff(index);
				buffName = RemoveUselessBuffsTooltipTextLeft1:GetText();
				if ( buffName ) then
					RemoveUselessBuffs_Setup.buffs[index] = buffName;
				else
					RemoveUselessBuffs_Setup.buffs[index] = "";
				end
			end
		else
			RemoveUselessBuffs_Setup.buffs[i] = "";
		end
	end
	local pri = 0;
	for k,v in RemoveUselessBuffs_Setup.buffsToRemove do
		RemoveUselessBuffs_Setup.buffsToRemove[k] = -1;
	end
	local removeIndex = 1;
	for priority=1,REMOVEUSELESSBUFFS_MAX_PRIORITY do
		for key, buffName in RemoveUselessBuffs_Setup.buffs do
			pri = REMOVEUSELESSBUFFS_BUFF_DATABASE[RemoveUselessBuffs_Setup.class][buffName];
			if ( pri ) and ( pri <= priority ) then
				RemoveUselessBuffs_Setup.buffsToRemove[removeIndex] = key;
				removeIndex = removeIndex + 1;
				removed = removed + 1;
				if ( numBuffs ) and ( removed >= numBuffs ) then
					break;
				end
			end
		end
		if ( numBuffs ) and ( removed >= numBuffs ) then
			break;
		end
	end
	local ok = true;
	local highestIndex, highest;
	while ok do
		highestIndex, highest = RemoveUselessBuffs_GetHighestRemoveIndex()
		RemoveUselessBuffs_Setup.buffsToRemove[highestIndex] = -1;
		if ( RemoveUselessBuffs_Setup.showRemoveMessage ) then 
			RemoveUselessBuffs_Print(format(REMOVEUSELESSBUFFS_REMOVED_BUFF_MESSAGE, RemoveUselessBuffs_Setup.buffs[highest]));
		end
		CancelPlayerBuff(highest);
	end
	return true;
end

function RemoveUselessBuffs_SlashCommand(msg)
	local state = REMOVEUSELESSBUFFS_STATE_DISABLED;
	if ( not RemoveUselessBuffs_Setup.showRemoveMessage ) then
		state = REMOVEUSELESSBUFFS_STATE_ENABLED;
		RemoveUselessBuffs_Setup.showRemoveMessage = true;
	else
		RemoveUselessBuffs_Setup.showRemoveMessage = false;
	end
	RemoveUselessBuffs_Print(format(REMOVEUSELESSBUFFS_MSG_STATE, state));
end

local frame = CreateFrame("Frame", "RemoveUselessBuffsFrame");
RemoveUselessBuffs_OnLoad(frame);



